#ifdef __GNUG__
#pragma implementation
#endif

static const char file_id[] = "CGDDFPortHole.cc";

#include "Block.h"
#include "CGDDFPortHole.h"
#include "CircularBuffer.h"

/**************************************************************************
Version identification:
@(#)CGDDFPortHole.cc	1.3	11/25/92

Copyright (c) 1990, 1991, 1992 The Regents of the University of California.
All rights reserved.

Permission is hereby granted, without written agreement and without
license or royalty fees, to use, copy, modify, and distribute this
software and its documentation for any purpose, provided that the above
copyright notice and the following two paragraphs appear in all copies
of this software.

IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY 
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES 
ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF 
THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF 
SUCH DAMAGE.

THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS.
							COPYRIGHTENDKEY

 Programmer:  Soonhoi Ha

Code for CGDDF-type portholes and multiportholes.

**************************************************************************/

int InCGDDFPort :: isItInput () const { return TRUE;}

// void InCGDDFPort :: grabData () { getParticle();}

int OutCGDDFPort :: isItOutput () const { return TRUE;}

// void OutCGDDFPort :: grabData () { clearParticle();}

// void OutCGDDFPort :: sendData () { putParticle();}

int MultiInCGDDFPort :: isItInput () const { return TRUE;}
int MultiOutCGDDFPort :: isItOutput () const { return TRUE;}

PortHole& MultiInCGDDFPort :: newPort () {
	LOG_NEW; PortHole& p = *new InCGDDFPort;
	p.numberTokens = numberTokens;
	return installPort(p);
}
 
PortHole& MultiOutCGDDFPort :: newPort () {
	LOG_NEW; PortHole& p = *new OutCGDDFPort;
	p.numberTokens = numberTokens;
	return installPort(p);
}
