/************************************************************************
 * SCCS Version identification :
 * @(#) 1.2 11/25/92
 *
Copyright (c) 1990, 1991, 1992 The Regents of the University of California.
All rights reserved.

Permission is hereby granted, without written agreement and without
license or royalty fees, to use, copy, modify, and distribute this
software and its documentation for any purpose, provided that the above
copyright notice and the following two paragraphs appear in all copies
of this software.

IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY 
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES 
ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF 
THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF 
SUCH DAMAGE.

THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS.
							COPYRIGHTENDKEY
 *
 * Programmer: Anders Wass
 * Date of creation:    6/11/91
 *
 * Description:
 *	This file defines a class that parsed a string by returning the
 *	contents of the string word by word. The words must be separated
 *	with white spaces. The class is initialized by contructor or
 *	assignment. The internal position pointer can be reseted without
 *	reinitialize the varable. The method returning the next word is
 *	called getword and takes no arguments. getword return NULL when the
 *	last word is returned.
 *
 ************************************************************************/

#ifndef _STRBUF_H_
#define _STRBUF_H_ 

class StrBuf
{
private:
    int   smbuf_size;
    char* smbuf;
    char* string;
    char* start;
public:
    StrBuf();
    StrBuf(const char*);
    ~StrBuf();
    void	reset() { start = string; }
    const char*	getword();
    const char* operator = (const char* nstr);
};

#endif
